package com.scalangular.f1.league.v2.usecases.common

import com.scalangular.f1.league.v2.entities.DriverRaceResult
import com.scalangular.f1.league.v2.generateDriver
import com.scalangular.f1.league.v2.generateDriverRaceResult
import com.scalangular.f1.league.v2.generateLeague
import com.scalangular.f1.league.v2.generateRace
import com.scalangular.f1.league.v2.generated.transfer.entitys.F1RaceResultStatus
import com.scalangular.f1.league.v2.generated.transfer.entitys.RaceResult
import com.scalangular.f1.league.v2.generated.transfer.entitys.toTransferModel
import com.scalangular.f1.league.v2.usecases.common.AutogenerateDNSForRaceResultUseCase.AutogenerateDNSForRaceResultCommand
import io.kotest.assertions.assertSoftly
import io.kotest.core.spec.style.StringSpec
import io.kotest.matchers.collections.shouldBeEmpty
import io.kotest.matchers.nulls.shouldNotBeNull
import io.kotest.matchers.shouldBe

class DefaultAutogenerateDNSForRaceResultUseCaseImplTest : StringSpec({

    val autogenerateDNSForRaceResultUseCase = DefaultAutogenerateDNSForRaceResultUseCase()

    val league = generateLeague()

    "add no dns when every driver took part" {
        val race = generateRace(league)

        val drivers = listOf(
            generateDriver(league),
            generateDriver(league)
        )

        val driverRaceResults = listOf(
            generateDriverRaceResult(drivers[0], race, 1),
            generateDriverRaceResult(drivers[1], race, 2)
        )

        val raceResultBeforeAdding = RaceResult(
            race.raceId,
            driverRaceResults.map { it.toTransferModel() }
        )

        val result = autogenerateDNSForRaceResultUseCase.addDNSToRaceResult(
            AutogenerateDNSForRaceResultCommand(
                raceResultBeforeAdding,
                drivers
            )
        )

        result shouldBe raceResultBeforeAdding
    }

    "add dns for each driver that did not took part" {
        val race = generateRace(league)

        val drivers = listOf(
            generateDriver(league),
            generateDriver(league),
            generateDriver(league)
        )

        val driverRaceResults = listOf(
            generateDriverRaceResult(drivers[0], race, 1),
            generateDriverRaceResult(drivers[1], race, 2)
        )

        val raceResultBeforeAdding = RaceResult(
            race.raceId,
            driverRaceResults.map { it.toTransferModel() }
        )

        val result = autogenerateDNSForRaceResultUseCase.addDNSToRaceResult(
            AutogenerateDNSForRaceResultCommand(
                raceResultBeforeAdding,
                drivers
            )
        )

        result.driverResults?.size shouldBe 3
    }

    "dont add any dns if no results exist" {
        val race = generateRace(league)

        val drivers = listOf(
            generateDriver(league),
            generateDriver(league),
            generateDriver(league)
        )

        val driverRaceResults = emptyList<DriverRaceResult>()

        val raceResultBeforeAdding = RaceResult(
            race.raceId,
            driverRaceResults.map { it.toTransferModel() }
        )

        val result = autogenerateDNSForRaceResultUseCase.addDNSToRaceResult(
            AutogenerateDNSForRaceResultCommand(
                raceResultBeforeAdding,
                drivers
            )
        )

        result.driverResults

        assertSoftly(result) {
            driverResults
                .shouldNotBeNull()
                .shouldBeEmpty()

            shouldBe(raceResultBeforeAdding)
        }
    }

    "generated dns is as expected" {
        val race = generateRace(league)

        val drivers = listOf(
            generateDriver(league),
            generateDriver(league),
            generateDriver(league)
        )

        val driverRaceResults = listOf(
            generateDriverRaceResult(drivers[0], race, 1),
            generateDriverRaceResult(drivers[1], race, 2)
        )

        val raceResultBeforeAdding = RaceResult(
            race.raceId,
            driverRaceResults.map { it.toTransferModel() }
        )

        val result = autogenerateDNSForRaceResultUseCase.addDNSToRaceResult(
            AutogenerateDNSForRaceResultCommand(
                raceResultBeforeAdding,
                drivers
            )
        ).driverResults?.last()

        val expected = com.scalangular.f1.league.v2.generated.transfer.entitys.DriverRaceResult(
            race.raceId,
            -1,
            -1,
            -1,
            -1f,
            -1.0,
            -1,
            -1f,
            -1,
            drivers.last().driverId,
            drivers.last().carNumber ?: -1,
            F1RaceResultStatus.notClassified
        )

        assertSoftly(result) {
            shouldNotBeNull()
            shouldBe(expected)
        }
    }

    "null driver results is handheld correctly" {
        val race = generateRace(league)

        val drivers = listOf(
            generateDriver(league),
            generateDriver(league),
        )

        val driverRaceResults = null

        val raceResultBeforeAdding = RaceResult(
            race.raceId,
            driverRaceResults
        )

        val result = autogenerateDNSForRaceResultUseCase.addDNSToRaceResult(
            AutogenerateDNSForRaceResultCommand(
                raceResultBeforeAdding,
                drivers
            )
        )

        assertSoftly(result) {
            shouldNotBeNull()
            shouldBe(raceResultBeforeAdding)
        }
    }
})
